<?php

/**
 * Base Class to use for the Add-ons
 * It will be used to extend the functionality of Analytify WordPress Plugin.
 */

ini_set( 'include_path', WP_PLUGIN_DIR .'/wp-analytify/lib/' );
define( 'ANALYTIFY_ID', 'wp-analytify-options' );
define( 'ANALYTIFY_NICK', 'Analytify' );
define( 'ANALYTIFY_ROOT_PATH', dirname(__FILE__) );
define( 'ANALYTIFY_VERSION', '1.0.3');
define( 'ANALYTIFY_DIR_PATH', plugin_dir_path( __FILE__ ) );
define( 'ANALYTIFY_LIB_PATH', dirname(__FILE__) . '/lib/' );
define( 'ANALYTIFY_CLIENTID', '707435375568-ujudvn46afvmh093lacrqrakui22dk6d.apps.googleusercontent.com' );
define( 'ANALYTIFY_CLIENTSECRET', 'bVsFyV0eBsWSKc_OfKGcyS_9' ); 
define( 'ANALYTIFY_REDIRECT', 'urn:ietf:wg:oauth:2.0:oob' );  // This will redirect to window where we can copy Access code.
define( 'ANALYTIFY_SCOPE', 'https://www.googleapis.com/auth/analytics' ); // readonly scope
define( 'ANALYTIFY_LIB_PATH', dirname(__FILE__) . '/lib/' );

if (! class_exists( 'Analytify_general' ) ) {

	class Analytify_General {

			/*const ANALYTIFY_ID           = 'wp-analytify-options'; 
			const ANALYTIFY_NICK         = 'Analytify'; 
			const ANALYTIFY_ROOT_PATH    =  dirname(__FILE__); 
			const ANALYTIFY_VERSION      = '1.0.3'; 
			const ANALYTIFY_DIR_PATH     =  plugin_dir_path( __FILE__ ) ; 
			const ANALYTIFY_LIB_PATH     =  dirname(__FILE__) . '/lib/'; 
			const ANALYTIFY_CLIENTID     = '707435375568-ujudvn46afvmh093lacrqrakui22dk6d.apps.googleusercontent.com'; 
			const ANALYTIFY_CLIENTSECRET = 'bVsFyV0eBsWSKc_OfKGcyS_9'; 
			const ANALYTIFY_REDIRECT     = 'urn:ietf:wg:oauth:2.0:oob'; 
			const ANALYTIFY_SCOPE        = 'https://www.googleapis.com/auth/analytics';*/

		function __construct() {

			if (! class_exists('Analytify_Google_Client') ) {

				require_once ANALYTIFY_LIB_PATH . 'Google/Client.php';
				require_once ANALYTIFY_LIB_PATH . 'Google/Service/Analytics.php';

		   }

			$this->client = new Analytify_Google_Client();
			$this->client->setApprovalPrompt( 'force' );
			$this->client->setAccessType( 'offline' );
			$this->client->setClientId( ANALYTIFY_CLIENTID );
			$this->client->setClientSecret( ANALYTIFY_CLIENTSECRET );
			$this->client->setRedirectUri( ANALYTIFY_REDIRECT );
			$this->client->setScopes( ANALYTIFY_SCOPE ); 

			try{
				$this->service = new Analytify_Google_Service_Analytics( $this->client );
			}
			catch ( Google_ServiceException $e ) {
				
			}
			$this->pa_connect();
		}

		public function pa_connect() {

			$ga_google_authtoken = get_option( 'pa_google_token' );

				if (! empty( $ga_google_authtoken )) {
					$this->client->setAccessToken( $ga_google_authtoken );
				} //!empty($ga_google_authtoken)
				else{
					$authCode = get_option( 'post_analytics_token' );
					
					if (empty($authCode)) return false;

					try {
						$accessToken = $this->client->authenticate( $authCode );
					}
					catch (Exception $e) {
						return false;
					}

					if ($accessToken) {
						$this->client->setAccessToken( $accessToken );
						update_option( 'pa_google_token', $accessToken );
						return true;
					} //$accessToken
					else {
						return false;
					}
				}
				$this->token = $this->client->getAccessToken();
				return true;
		}

		public function pa_get_analytics( $metrics, $startDate, $endDate, $dimensions = false, $sort = false, $filter = false, $limit = false ){

			$this->service = new Analytify_Google_Service_Analytics($this->client);
			$params        = array();
			if ($dimensions){
				$params['dimensions'] = $dimensions;
			} //$dimensions
			if ($sort){
				$params['sort'] = $sort;
			} //$sort
			if ($filter){
				$params['filters'] = $filter;
			} //$filter
			if ($limit){
				$params['max-results'] = $limit;
			} //$limit
			$profile_id = get_option( 'pt_webprofile' );

			if (!$profile_id){
				return false;
			}
				
			return $this->service->data_ga->get( 'ga:' . $profile_id, $startDate, $endDate, $metrics, $params);
		}

		public function pa_get_analytics_dashboard($metrics, $startDate, $endDate, $dimensions = false, $sort = false, $filter = false, $limit = false){

			$this->service = new Analytify_Google_Service_Analytics($this->client);
			$params        = array();
			if ($dimensions){
				$params['dimensions'] = $dimensions;
			}
			if ($sort){
				$params['sort'] = $sort;
			} 
			if ($filter){
				$params['filters'] = $filter;
			} 
			if ($limit){
				$params['max-results'] = $limit;
			} 
				
			$profile_id = get_option( 'pt_webprofile_dashboard' );
				
			if (!$profile_id){
				return false;
			}
				
			return $this->service->data_ga->get('ga:' . $profile_id, $startDate, $endDate, $metrics, $params);
		}
	}
}
?>