<?php
  $wp_analytify = new WP_Analytify();

  if (! function_exists( 'curl_init' ) ) {
      esc_html_e('This plugin requires the CURL PHP extension');
    return false;
  }

  if (! function_exists( 'json_decode' ) ) {
    esc_html_e('This plugin requires the JSON PHP extension');
    return false;
  }

  if (! function_exists( 'http_build_query' )) {
    esc_html_e('This plugin requires http_build_query()');
    return false;
  }

  $url = http_build_query( array(
                                'next'          =>  $wp_analytify->pa_setting_url(),
                                'scope'         =>  ANALYTIFY_SCOPE,
                                'response_type' =>  'code',
                                'redirect_uri'  =>  ANALYTIFY_REDIRECT,
                                'client_id'     =>  ANALYTIFY_CLIENTID
                                )
                          );

  // Save access code
  if ( isset( $_POST["save_code"] ) ) {
    $key_google_token = $_POST["key_google_token"];
    
    if( $wp_analytify->pt_save_data( $key_google_token )){
        $update_message = '<div id="setting-error-settings_updated" class="updated settings-error below-h2"><p><strong>Access code saved</strong></p></div>';
    }
  }

  $postkey_google_token = get_option('post_analytics_token');

  // Saving settings for front end Analytics for Posts and Pages.
  if ( isset( $_POST[ 'save_settings_front' ] ) ){

    if(isset($_POST[ 'frontend' ])) update_option('post_analytics_settings', $_POST[ "frontend" ]);
    
    update_option( 'post_analytics_access', $_POST[ 'access_role' ]);
    if( isset( $_POST[ 'disable_front' ] ) ) {
      update_option( 'analytify_disable_front', 1 );
    }
    else{
       update_option( 'analytify_disable_front', 0 );
    }
    if( isset( $_POST[ 'showguest' ] ) ) {
      update_option( 'post_analytics_showguest', 1 );
    }
    else{
       update_option( 'post_analytics_showguest', 0);
    }
    $update_message = '<div id="setting-error-settings_updated" class="updated settings-error below-h2"><p><strong>Front end settings saved.</strong></p></div>';
  
  } // endif 
  // Saving settings for back end Analytics for Posts and Pages.
  if ( isset( $_POST[ 'save_settings_admin' ] ) ) {

    update_option( 'post_analytics_settings_back' , $_POST[ 'backend' ] );
    update_option( 'post_analytics_access_back' , $_POST[ 'access_role_back' ] );
    
    $update_message = '<div id="setting-error-settings_updated" class="updated settings-error below-h2"><p><strong>Admin settings saved.</strong></p></div>';
  
  } // endif

  // Saving Profiles
  if (isset($_POST[ "save_profile" ])) {
    $profile_id            = $_POST[ 'webprofile' ];
    $tracking_code         = $_POST[ 'tracking_code' ];
    $web_profile_dashboard = $_POST[ 'webprofile_dashboard' ];
    $web_profile_url       = $_POST[ $web_profile_dashboard ];
    $webPropertyId         = $_POST[ $profile_id."-1"];
    update_option( 'pt_webprofile', $profile_id );
    update_option( 'webPropertyId', $webPropertyId);
    update_option( 'pt_webprofile_dashboard', $web_profile_dashboard );
    update_option( 'pt_webprofile_url', urldecode( urldecode( $web_profile_url )));
    update_option( 'analytify_tracking_code', $tracking_code);
     if( isset( $_POST[ 'ga_code' ] ) ) {
      update_option( 'analytify_code', 1 );
    }
    else{
       update_option( 'analytify_code', 0 );
    }
    $update_message = '<div id="setting-error-settings_updated" class="updated settings-error below-h2"> 
                        <p><strong>Your Google Analytics Profile Saved.</strong></p></div>';
  }

  // Clear Authorization and other data
  if (isset($_POST[ "clear" ])) {

    delete_option( "pt_webprofile" );
    delete_option( "pt_webprofile_dashboard" );
    delete_option( "pt_webprofile_url" );
    delete_option( "pa_google_token" );
    delete_option( "pa_welcome_message" );
    delete_option( "post_analytics_token" );
    $update_message = '<div id="setting-error-settings_updated" class="updated settings-error below-h2"> 
                        <p><strong>Authentication Cleared login again.</strong></p></div>';
  }
?>

<div class="wrap">
  <h2 class='opt-title'><span id='icon-options-general' class='analytics-options'><img src="<?php echo plugins_url('wp-analytify/images/wp-analytics-logo.png');?>" alt=""></span>
    <?php echo __( 'Analytify Plugin Settings', 'wp-analytify'); ?>
  </h2>
  
  <?php
  if (isset($update_message)) echo $update_message;
  
  if ( isset ( $_GET['tab'] ) ) $wp_analytify->pa_settings_tabs($_GET['tab']); 
  else $wp_analytify->pa_settings_tabs( 'authentication' );

  if ( isset ( $_GET['tab'] ) ) 
    $tab = $_GET['tab']; 
  else 
    $tab = 'authentication';
  
  // Authentication Tab section
  if( $tab == 'authentication' ) {
  ?>

  <form action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post" name="settings_form" id="settings_form">
    <table width="1004" class="form-table">
      <tbody>
      <?php if( get_option( 'pa_google_token' ) ) { ?>
        <tr>
          <p>Do you want to re-authenticate ? Click reset button and get your new Access code.<p>
          
        </tr>
        <tr>
          <th><?php esc_html_e( 'Clear Authentication', 'wp-analytify' ); ?></th>
          <td><input type="submit" class="button-primary" value="Reset" name="clear" /></td>
        </tr>
      <?php 
      }
      else { ?>
        <tr>
          <th width="115"><?php esc_html_e( 'Authentication:' )?></th>
              <td width="877">
                    <a target="_blank" href="javascript:void(0);" onclick="window.open('https://accounts.google.com/o/oauth2/auth?<?php echo $url ?>','activate','width=700,height=500,toolbar=0,menubar=0,location=0,status=1,scrollbars=1,resizable=1,left=0,top=0');">Click here to Authenticate</a>
              </td>
        </tr>
        <tr>
              <th><?php esc_html_e('Your Access Code:')?> </th>
              <td>
                <input type="text" name="key_google_token" value="<?php echo $postkey_google_token ?>" style="width:450px;"/>
              </td>
        </tr>
        <tr>
          <th></th>
          <td>
            <p class="submit">
              <input type="submit" class="button-primary" value = "Save Changes" name = "save_code" />
            </p>
          </td>
        </tr>
      <?php } ?>
      </tbody>
    </table>
  </form>
  <?php 
  } // endif
// Choose profiles for dashboard and posts at front/back.
if( $tab == 'profile' ){
  $profiles = $wp_analytify->pt_get_analytics_accounts();
  if( isset( $profiles ) ) { ?>
    <p><?php esc_html_e( 'Select profiles for front-end and backend sections.', 'wp-analytify' ); ?></p>

    <form action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post">
      <table width="1004" class="form-table">
        <tbody>
        <tr>
            <th width="115"><?php esc_html_e( 'Enable Tracking code :', 'wp-analytify' ); ?></th>
              <td width="877">
              <input type="checkbox" name="ga_code" value="1" 
                  <?php if( get_option( 'analytify_code' ) == 1 ) { echo 'checked'; } ?>>
              </td>
        </tr>
        <tr>
            <th width="115"><?php esc_html_e( 'Tracking code type :', 'wp-analytify' ); ?></th>
              <td width="877">
              <select name='tracking_code' id='tracking_code'>
                <option value="universal" <?php selected( 'universal', get_option( 'analytify_tracking_code' ) ); ?>>
                  Universal Code (analytics.js)
                </option>
                <option value="ga"  <?php selected( 'ga', get_option( 'analytify_tracking_code' ) ); ?>>
                  Tranditional Code (ga.js)
                </option>
                 
              </select>
              </td>
        </tr>
          <tr>
            <th width="115"><?php esc_html_e( 'Posts (Backend/Frontend) :', 'wp-analytify' ); ?></th>
              <td width="877">
              <?php //print_r($profiles->items); ?>
                <select name='webprofile' id='webprofile'>
                  <?php foreach ( $profiles->items as $profile ) { ?>
                        <option value="<?php echo $profile[ 'id' ];?>"
                                <?php selected( $profile[ 'id' ], get_option( 'pt_webprofile' ) ); ?>>
                                <?php echo $profile[ 'websiteUrl' ];?> - <?php echo $profile[ 'name' ];?>
                        </option>
                  <?php } ?>
                </select>
                 <?php 
                foreach ( $profiles->items as $profile ) { ?>
                  <input type="hidden" name="<?php echo $profile[ 'id' ]; ?>-1" value="<?php echo $profile['webPropertyId'] ?>">
                <?php } ?>
              </td>
          </tr>
          <tr>
            <th width="115"><?php esc_html_e( 'Dashboard :', 'wp-analytify' );?></th>
            <td width="877">
                <select name='webprofile_dashboard' id='webprofile-dashboard'>
                  <?php foreach ($profiles->items as $profile) { ?>
                  <option value="<?php echo $profile[ 'id' ];?>"
                              <?php selected( $profile[ 'id' ], get_option( 'pt_webprofile_dashboard' )); ?>
                              >
                              <?php echo $profile[ 'websiteUrl' ];?> - <?php echo $profile[ 'name' ];?>-
                  </option>
                  <?php } ?>
                </select>
                <?php 
                foreach ( $profiles->items as $profile ) { ?>
                  <input type="hidden" name="<?php echo $profile[ 'id' ]; ?>" value="<?php echo urlencode(urlencode($profile[ 'websiteUrl' ])); ?>">
                <?php } ?>
            </td>
          </tr>
          <tr>
            <th></th>
            <td>
              <p class="submit">
                <input type="submit" name="save_profile" value="Save Changes" class="button-primary">
              </p>
            </td>
          </tr>
          <?php } ?>
      </tbody>
    </table>
  </form>
<?php }

// Choose metrics for posts at front.
if( $tab == 'front' ) { ?>
  <p><?php esc_html_e('Select which panels you want to see Analytics under the posts/pages at frontend..', 'wp-analytify' ); ?></p>

  <form action="" method="post">
    <table width="1004" class="form-table">
      <tbody>
      <tr>
        <th width="115"><?php esc_html_e( 'Disable frontend ?', 'wp-analytify' ); ?></th>
        <td>
          <input type="checkbox" name="disable_front" id="disable_front" value = "1"
            <?php if( get_option( 'analytify_disable_front') == 1 ) { echo 'checked'; } ?>>
        </td>
      </tr>
      <tr>
        <th width="115">
          <div class="disable" <?php if( get_option( 'analytify_disable_front' ) == 1) { ?> style="display:none;" <?php } ?>>  
            <?php esc_html_e( 'Show statistics to guest visitors ?', 'wp-analytify' ); ?></th>
          </div>
        <td>
          <div class="disable" <?php if( get_option( "analytify_disable_front" ) == 1) { ?> style="display:none;" <?php } ?>>  
          <input type="checkbox" name="showguest" id="showguest" value = "1"
            <?php if( get_option('post_analytics_showguest') == 1 ) { echo 'checked'; } ?>>
        </div>
        </td>
      </tr>
      <tr>
        <th width="115">
          <div class="disable" <?php if( get_option( 'analytify_disable_front' ) == 1) { ?> style="display:none;" <?php } ?>>  
          <div class="guest-show" <?php if( get_option( 'post_analytics_showguest' ) == 1) { ?> style="display:none;" <?php } ?>>
            <?php esc_html_e( 'Show statistics to (roles):', 'wp-analytify' ); ?>
          </div>
          </div>
        </th>
        <td>
          <div class="disable" <?php if( get_option( 'analytify_disable_front' ) == 1) { ?> style="display:none;" <?php } ?>>  
          <div class="guest-show" <?php if( get_option( 'post_analytics_showguest' ) == 1) { ?> style="display:none;" <?php } ?>>
            <select multiple name="access_role[]" id="access_role" >
              <?php
              if ( !isset( $wp_roles ) ) {
                $wp_roles = new WP_Roles();
              }
              $i = 0;
              
              foreach ( $wp_roles->role_names as $role => $name ) { ?>
                <option value="<?php echo $role; ?>" <?php if ( $role == 'administrator' ) echo 'selected'; ?> 
                <?php
                if ( is_array( get_option( 'post_analytics_access' ) ) ) {
                  selected( in_array( $role, get_option('post_analytics_access') ) );
                }
                ?>>
                <?php echo $name; ?>
                </option>
              <?php 
              } // end foreach
              ?>
            </select>
          </div>
          </div>   
        </td>
      </tr> 
      <tr>
        <th></th>
        <td>
          <p class="submit"> <input type="submit" name="save_settings_front" value="Save Changes" class="button-primary"></p>
        </td>
      </tr>
    </tbody>
  </table>
  </form>
  <?php }
  
  // Choose metrics for posts at admin.
  if( $tab == 'admin' ) { ?>
    <p><?php esc_html_e('Select which panels you want to see Analytics under the posts/pages at wp-admin and Analytics dashboard.', 'wp-analytify' ); ?></p>

    <form action="" method="post">
      <table width="1004" class="form-table">
        <tbody>
          <tr></tr>
          <tr>
            <!-- Area For backend settings -->
            <th width="115"><?php esc_html_e( 'BackEnd Statistics:' ); ?></th>
            <td>
              <select id="backend" name="backend[]" multiple="multiple">
                <option value="show-overall-back"
                        <?php
                        if ( is_array( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected(in_array("show-overall-back", get_option('post_analytics_settings_back')));
                        }
                        ?>>
                        <?php esc_html_e( 'Show Overall Stats' )?>
                </option>
                <option value="show-country-back"
                        <?php
                        if ( is_array( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-country-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Country Stats' )?>
                </option>
                
                <option value="show-keywords-back"
                        <?php
                        if ( is_array ( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-keywords-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Keywords Stats' ); ?>
                </option>
                <option value="show-social-back"
                        <?php
                        if ( is_array ( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-social-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Social Media Stats' ); ?>
                </option>
                <option value="show-browser-back"
                        <?php
                        if ( is_array( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-browser-back", get_option( 'post_analytics_settings_back') ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Browser Stats' ); ?>
                </option>
                <option value="show-referrer-back"
                        <?php
                        if ( is_array( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-referrer-back", get_option( 'post_analytics_settings_back') ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Referrer' ); ?>
                </option>
                <option value="show-pages-back"
                        <?php
                        if ( is_array( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-pages-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e('Show Pages'); ?>
                </option>
                <option value="show-mobile-back"
                        <?php
                        if ( is_array ( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-mobile-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Mobile data' ); ?>
                </option>
                <option value="show-os-back"
                        <?php
                        if ( is_array ( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-os-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show Operating System Stats' ); ?>
                </option>
                <option value="show-city-back"
                        <?php
                        if ( is_array ( get_option( 'post_analytics_settings_back' ) ) ) {
                          selected( in_array( "show-city-back", get_option( 'post_analytics_settings_back' ) ) );
                        }
                        ?>>
                        <?php esc_html_e( 'Show City Stats' ); ?>
                </option>
              </select>
            </td>
          </tr>
          <tr>
            <th width="115"><?php esc_html_e( 'Show statistics to (roles):', 'wp-analytify' ); ?></th>
            <td>
              <select multiple name="access_role_back[]" id="access_role_back">
                <?php
                if ( !isset( $wp_roles ) ){
                  $wp_roles = new WP_Roles();
                }
                $i=0;
                foreach ( $wp_roles->role_names as $role => $name ) {
                  if ($role!='subscriber'){
                    $i++;
                    ?>
                    <option value="<?php echo $role; ?>" <?php if ($role=='administrator') echo 'selected'; ?>
                      <?php
                      if ( is_array( get_option( 'post_analytics_access_back' ) ) ) {
                        selected( in_array( $role, get_option( 'post_analytics_access_back' ) ) );
                      }
                      ?>>
                      <?php echo $name; ?>
                    </option>
                    <?php
                  }
                }
                ?>
              </select>
            </td>
          </tr>
          <tr>
            <th></th>
            <td>
              <p class="submit">
                <input type="submit" name="save_settings_admin" value="Save Changes" class="button-primary">
              </p>
            </td>
          </tr>
        </tbody>
      </table>
    </form>
  <?php 
  }
  // Plugin license Tab section
  if( $tab == 'license' ) {
      $license  = get_option( 'analytify_license_key' );
      $status   = get_option( 'analytify_license_status' );
      //var_dump($license);
    ?>
    <div class="wrap">
    <h2><?php _e('Plugin License Options', 'wp-analytify'); ?></h2>
    <form method="post" action="options.php">
    
      <?php settings_fields('analytify-settings'); ?>
      
      <table class="form-table">
        <tbody>
          <tr valign="top"> 
            <th scope="row" valign="top">
              <?php _e('License Key', 'wp-analytify'); ?>
            </th>
            <td>
              <input id="analytify_license_key" name="analytify_license_key" type="text" class="regular-text" value="<?php esc_attr_e( $license ); ?>" />
              <label class="description" for="analytify_license_key"><?php _e('Enter your license key'); ?></label>
            </td>
          </tr>
          <?php if( false !== $license ) { ?>
            <tr valign="top"> 
              <th scope="row" valign="top">
                <?php _e('Activate License'); ?>
              </th>
              <td>
                <?php if( $status !== false && $status == 'valid' ) { ?>
                  <span style="color:green;"><?php _e('Active'); ?></span>
                  <?php wp_nonce_field( 'analytify_nonce', 'analytify_nonce' ); ?>
                  <input type="submit" class="button-secondary" name="analytify_license_deactivate" value="<?php _e('Deactivate License'); ?>"/>
                <?php } else {
                  wp_nonce_field( 'analytify_nonce', 'analytify_nonce' ); ?>
                  <input type="submit" class="button-secondary" name="analytify_license_activate" value="<?php _e('Activate License'); ?>"/>
                <?php } ?>
              </td>
            </tr>
          <?php } ?>
        </tbody>
      </table>  
      <?php submit_button(); ?>
    
    </form>
  <?php } ?>

</div>
</div>
<div class="right-area">
  <div class="postbox-container side">
    <script type="text/javascript" src="http://wpbrigade.com/updates/syndicate-analytify.php"></script>
        <div class="metabox-holder">
          <div class="grids_auto_size wpa_side_box" style="width: 95%;">
            <div class="grid_title cen"> HELP </div>
                
                <div class="grid_footer cen" style="background-color:white;">
                <a href="http://wpbrigade.com/forums/forum/analytify-makes-google-analytics-simple-for-wordpress/" title="Analytify Support">Click here</a> to get the support of Analytify. You can submit bug reports and give us suggestions as well.
                </div>
          </div>
          <div class="grids_auto_size wpa_side_box" style=" width: 95%;">
            <div class="grid_title cen"> CREDITS </div>
                
                <div class="grid_footer cen" style="background-color:white;">
                  <a href="http://wp-analytify.com" title="Analytify WordPress Plugin" />Analytify - Makes Google Analytics Simple for WordPress.</a><br><br>
                  Product by <a href="http://wpbrigade.com" title="WPBrigade | A Brigade of WordPress Developers." />WPBrigade</a>.
                </div>
          </div>
       </div>
  </div>
</div>
</div>